module Noodle
  class Node
    attr_accessor :name, :content
    attr_reader   :parent, :childs
    # for next & previous must be going to by the parent node

    # you need to add name optionnaly you can set value for attributes node
    def initialize(name_node, hash_node = nil)
      @name     = name_node
      @values   = hash_node || {}
      @next     = nil
      @previous = nil
      @parent   = nil
      @content  = nil
      @childs   = []
    end
    
    # attr(key) where key is a string :
    # getter method
    # attr(key, value) key=string, value=string :
    # setter method
    # attr(key) key=Hash :
    # setter method for all pair key/value in params value
    def attr(key, value = nil)
      if key.class == "Hash"
        key.each {|keyt, val| @values[keyt] = val}
      elsif value.nil?
        return @values[key] if @values.has_key? key
      else
        @values[key] = value
      end
      puts "#{@values.inspect}"
      return nil
    end

    # Return all values containt by node
    def listAttr
      data = []
      @values.each {|key, val| data.push key}
      return data
    end

    # Delete all attr values
    def deleteAttr(key)
      if @values.has_key? key
        @values.delete(key)
        return true
      end
      return false
    end

    # Set value parent, you need to pass a Noodle::Node class
    def setParent(parent)
      @parent = parent
    end

    # Create child same parametre that Noodle::Node and this node is adding to child
    def newChild(name, hash_tab = nil)
      nchild = Noodle::Node.new(name, hash_tab)
      addChild(nchild)
      return nchild
    end

    # Add Noodle::Node to childs' node 
    def addChild(child)
      child.setParent(self)
      @childs.push child
    end

    # jump to the next node if exist return nil if he doesn't exist
    def next
      return (@parent ? @parent.childNext(self) : nil)
    end

    # jump to the previous node if exist return nil if he doesn't exist
    def previous
      return (@parent ? @parent.childPrevious(self) : nil)
    end

    # Convert Object and all childs NOT parent in xml
    # Set content, becarefull we can add childs && content set !
    # Content are printing in to_xml if are not null
    def to_xml
      return "<#{@name}#{values_str} />" if content.nil? && @childs.empty?
      data = "<#{@name}#{values_str}>"
      if @content.nil?
        @childs.each do |child|
          data += child.to_xml
        end
      else
        data += @content
      end
      data += "</#{@name}>"
    end

    private

    def childNext(node_child)
      return_child(iter_child(node_child) + 1)
    end

    def childPrevious(node_child)
      return_child(iter_child(node_child) - 1)
    end

    def values_str
      data = ""
      @values.each do |key, val|
        data += " #{key}=\"#{val}\""
      end
      return data
    end

    def iter_child(obj_node)
      i = 0
      while @childs.length > i
        return i if @childs[i] = obj_node
        i += 1
      end
      return i
    end

    def return_child(i)
      return (i < @childs.length && i >= 0 ? @childs[i] : nil)
    end
  end
end